import { AllLayoutAlgorithms, LayoutFactory } from '@graphpolaris/graph-layout';
import { createReactFlowElements } from '@graphpolaris/schema/usecases';
import {
  useSchema,
  useSchemaLayout,
} from '@graphpolaris/shared/data-access/store';
import { MultiGraph } from 'graphology';
// import { AllLayoutAlgorithms, LayoutFactory } from '@graphpolaris/graph-layout';
import { useEffect, useState } from 'react';
import ReactFlow, { FlowElement, ReactFlowProvider } from 'react-flow-renderer';

interface Props {
  // content: string;
}

const onLoad = (reactFlowInstance: any) => {
  setTimeout(() => reactFlowInstance.fitView(), 0);
};

const Schema = (props: Props) => {
  const [elements, setElements] = useState([] as FlowElement[]);
  // In case the schema is updated
  const dbschema = useSchema();
  // const [dbschema, setSchema] = useState(useSchema());
  const [schemaLayout, setSchemaLayout] = useState(useSchemaLayout());

  useEffect(() => {
    console.log('dbSchema', dbschema, dbschema.order);
  }, [dbschema]);

  useEffect(() => {
    if (dbschema == undefined || dbschema.order == 0) {
      return;
    }
    const layoutFactory = new LayoutFactory();
    console.log('schema Layout', schemaLayout, 'order', dbschema.order);
    const layout = layoutFactory.createLayout(
      schemaLayout as AllLayoutAlgorithms
    );
    layout?.layout(dbschema);

    // dbschema.forEachNode((node, attr) => {
    //   console.log('x', dbschema.getNodeAttribute(node, 'x'));
    //   console.log('y', dbschema.getNodeAttribute(node, 'y'));
    // });

    const flowElements = createReactFlowElements(dbschema);
    setElements(flowElements);
    console.log(
      'update schema useEffect',
      dbschema,
      dbschema.order,
      flowElements
    );
  }, [dbschema, schemaLayout]);

  const graphStyles = { width: '100%', height: '500px' };

  return (
    <div
      style={{
        width: '100%',
        height: '100%',
      }}
    >
      {elements.length == 0 && <p>DEBUG: No Elements</p>}
      <ReactFlowProvider>
        <ReactFlow elements={elements} style={graphStyles} onLoad={onLoad} />
        {/* // onElementsRemove={onElementsRemove}
        // onConnect={onConnect}
        // 
        snapToGrid={true}
        snapGrid={[15, 15]}
      ></ReactFlow> */}
      </ReactFlowProvider>
    </div>
  );
};

export default Schema;

// Fix layout of the schema
// create reactflow elements on xy coords
// connect reactflow elements together

// maybe ook gelijk instellingen knoppie fixen op alle panels
